#if !defined(charbmpH)
#define charbmpH

#include "SDL.h"

typedef struct{
    SDL_Surface *surface;       /* W̃T[tFCX */
    SDL_Surface *surface_tmp;   /* `pꎞT[tFCX */
    int code_table[65536];      /* R[hƃp^[ԍ̕ϊe[u */
    int chr_w;                  /* iSṕj */
    int chr_h;                  /* c */
    int chr_xcount;             /* ɕł镶 */
}CHR_FONT_BMP;

int load_char_bmp(CHR_FONT_BMP *font_bmp, const char *file_code, const char *file_bmp, int chr_w, int chr_h, const char *font_name);
void free_char_bmp(CHR_FONT_BMP *font_bmp);
int draw_char_rgba(CHR_FONT_BMP *font_bmp, SDL_Surface *dst, int x, int y, int code, Uint32 rgba);
int draw_char(CHR_FONT_BMP *font_bmp, SDL_Surface *dst, int x, int y, int code);
int draw_string_rgba(CHR_FONT_BMP *font_bmp, SDL_Surface *dst, int x, int y, const char *str, Uint32 rgba);
int draw_string(CHR_FONT_BMP *font_bmp, SDL_Surface *dst, int x, int y, const char *str);

#endif
