#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "fpscount.h"

/* FPSZopzAyєz񒆂݈̌ʒuB */
struct TFPS_COUNTER{
    int last_tick_index;
    /* mۂꂽz񒷁B */
    int array_size;
    /* ϒzBC99ȂY0Ə邪Ał͌Â`B */
    Uint32 last_ticks[1];
};

/*<---------------------------------------------------------------------->*/
/* \̊mہB͎Zopz̒B */
FPS_COUNTER *fps_alloc(int array_size)
{
    FPS_COUNTER *p;
    size_t sz;

    sz = sizeof(FPS_COUNTER) + (array_size-1)*sizeof(Uint32);
    p = (FPS_COUNTER *)malloc(sz);
    memset(p, 0, sz);
    p->array_size = array_size;
    return p;
}
/*<---------------------------------------------------------------------->*/
void fps_free(FPS_COUNTER *p)
{
    free(p);
}
/*<---------------------------------------------------------------------->*/
/* zHFPS߂B */
static int get_fps(const FPS_COUNTER *fps_data, Uint32 tick)
{
    int i;
    int fps = 0;

    /* L^zɒHĒOPbԂ̃t[߂B */
    for(i=fps_data->last_tick_index-1; i>=0; i--){
        if(fps_data->last_ticks[i]+1000 < tick){
            return fps;
        }
        fps++;
    }
    for(i=fps_data->array_size-1; i>=fps_data->last_tick_index; i--){
        if(fps_data->last_ticks[i]+1000 < tick){
            return fps;
        }
        fps++;
    }
    /* ɗ邱ƂƂ܂BȂ͂B */
    fprintf(stderr, "xFFPSZopz񂪂ӂĂ鋰ꂪ܂B\n");
    return fps;
}
/*<---------------------------------------------------------------------->*/
/* FPSZo鎞͂̊֐t[ĂяoB */
int fps_count_fps(FPS_COUNTER *fps_data, Uint32 tick_now)
{
    int fps;
    Uint32 tick;

    /* ŏ͎z̓eȂ̂1000悹Ďn߂B */
    tick = tick_now + 1000;
    fps = get_fps(fps_data, tick);
    fps_data->last_ticks[fps_data->last_tick_index] = tick;
    fps_data->last_tick_index++;
    if(fps_data->last_tick_index == fps_data->array_size){
        fps_data->last_tick_index = 0;
    }
    return fps;
}
/*<---------------------------------------------------------------------->*/
