#include <stdio.h>
#include <string.h>
#include "SDL.h"
#include "actmain.h"
#include "fps.h"

typedef unsigned int DWORD;

#define KEYQUEUE_MAX 256

/*<---------------------------------------------------------------------->*/
static void elapse_time(void) /* (C)yaneurao 1998-1999 */
{
/* lmǂԑ҂ */
    static DWORD lastdraw = 0; /* O̕`掞 */
    /* is^ɂꔭڂtimeGetTime() == 0Ƃ[Ƃ邪A͍\Ȃj */
    const DWORD dwFPSWait = (1000 * 0x10000)/FRAME_PER_SEC;
    DWORD t, dwFPSWaitTT, dwWait, dwElp;

/*    if (iFPS == 0)
        return ; *//* Non-wait mode */

    t = SDL_GetTicks(); // ݎ

    dwFPSWaitTT = (dwFPSWaitTT & 0xffff) + dwFPSWait; // ̑҂ԂvZ

    /*
     * dwFPSWait́A҂Ԃ̏ȉPUrbg̐xŎĂƍl
     * ɂAdouble^oKvȂȂB
     * dwFPSWaitTT = 1000 * 0x10000 / FPS;ł
     */

    dwWait = dwFPSWaitTT >> 16; /* ǂ̂ƂA͉ms҂˂H */

    /* Pt[Ԃo߂Bɕ`悵ȂႢI */
    dwElp = (DWORD)(t - lastdraw); /* O`悩炢o߂Ƃ˂H */
    if (dwElp>=dwWait) {
        lastdraw = t;
        return ;
    }

    /* قȁAԂׂƂI */

    /* ܂Ԃ͂Ղ肠̂H */
    /* 4msȏKv̂Ȃ΁ASleep */
    if (dwWait-dwElp >= 4)
        SDL_Delay(dwWait-dwElp-3);
    /* dwWait>dwElpȂ̂dwWait-dwElp>=0ƍlėǂ */

    /*
     * 95/98/NTő肵ƂSleep(1);1msPʂŃX[v͉̂\
     * Anˑ̉\̂Sleep̐x3msȓƉ
     */
    while ((SDL_GetTicks()-lastdraw)<dwWait) ;
    /* [vŎԂׂi܂DȂǁj */

    /* ŁAԂԂI */

    lastdraw += dwWait; /* ҂ŕ`悪肷Bi[܂Ȃ߁j */
}
/*<---------------------------------------------------------------------->*/
static void event_loop(SDL_Surface *screen)
{
    SDL_Event event;
    SDL_keysym keyqueue[KEYQUEUE_MAX];
    int keyqueue_count;
    void *state_data;
    int ret;

    int running = 1;

    if(act_init(&state_data) == -1){
        printf("failed to init.\n");
        return;
    }
    while(running){
        keyqueue_count = 0;
        while(SDL_PollEvent(&event)){  
            switch(event.type){  
            case SDL_KEYDOWN:
                /* ŃL[{[h֌W̏ */
                /* L[ɓB^CsOQ[Ȃ̂łȎ蔲łƂȂB */
                if(keyqueue_count < KEYQUEUE_MAX &&
                   event.key.keysym.sym != SDLK_RSHIFT && /* VtgL[P͖̂B */
                   event.key.keysym.sym != SDLK_LSHIFT){
                    keyqueue[keyqueue_count] = event.key.keysym;
                    /*
                     * {L[{[hBackspaceL[̍̃L[
                     * keysym.sym ɒlȂ̂ŉ~LƂĂB
                     */
                    if(keyqueue[keyqueue_count].scancode == 125){
                        keyqueue[keyqueue_count].sym = '\\';
                    }
                    /* ^L['^'ɁB */
                    if(keyqueue[keyqueue_count].scancode == 144){
                        keyqueue[keyqueue_count].sym = '^';
                    }
                    /* @L['@'ɁB */
                    if(keyqueue[keyqueue_count].scancode == 145){
                        keyqueue[keyqueue_count].sym = '@';
                    }
                    /* :L[':'ɁB */
                    if(keyqueue[keyqueue_count].scancode == 146){
                        keyqueue[keyqueue_count].sym = ':';
                    }
                    keyqueue_count++;
                }
/*
                printf("mod,sym,scancode,unicode = %d,%d,%d,%d\n", event.key.keysym.mod, event.key.keysym.sym, event.key.keysym.scancode, event.key.keysym.unicode);
                if(' ' <= event.key.keysym.unicode && event.key.keysym.unicode <= '\\')
                    printf("unicode : %c\n", event.key.keysym.unicode);
                else
                    printf("unicode = %d\n", event.key.keysym.unicode);
*/
                break;
            case SDL_KEYUP:
                break;
            case SDL_QUIT:
                running = 0;
                break;
            }
        }
        ret = act_callback(screen, keyqueue, keyqueue_count, &state_data);
        if(!ret || ret == -1)
            break;
        elapse_time();
    }
    act_end(&state_data);
}
/*<---------------------------------------------------------------------->*/
int main(int argc, char *argv[])
{
    SDL_Surface *screen;

    printf("SDL̏Ă܂B\n");

    /* rfIƃI[fBIAꂩftHg̃TuVXe */
    if((SDL_Init(SDL_INIT_VIDEO|SDL_INIT_AUDIO)==-1)) {
        printf("SDL̏ł܂ł: %s.\n", SDL_GetError());
        return -1;
    }

    printf("SDL̏܂B\n");

    /* 8-bit w肵AǂȐ[xł\ */
    screen = SDL_SetVideoMode(640, 480, 16, SDL_SWSURFACE|SDL_ANYFORMAT);
    if ( screen == NULL ) {
        fprintf(stderr, "640x480x16 ̃rfI[hɐݒł܂ł: %s\n",
                        SDL_GetError());
        return -1;
    }
    printf("640x480 at %d bpp ̃[h 640x480 ɐݒ肵܂\n",
           screen->format->BitsPerPixel);

    event_loop(screen);

    printf("SDLIĂ܂B\n");

    /* SẴTuVXeVbg_E܂ */
    SDL_Quit();

    printf("I܂....\n");

    return 0;
}
